"""
    CCF-API

    This API provides programmatic access to data registered to the CCF. See the [HuBMAP CCF Portal](https://hubmapconsortium.github.io/ccf/) for details.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ccf_openapi_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from ccf_openapi_client.exceptions import ApiAttributeError


def lazy_import():
    from ccf_openapi_client.model.json_ld_object import JsonLdObject
    from ccf_openapi_client.model.rgba import Rgba
    from ccf_openapi_client.model.spatial_entity_common import SpatialEntityCommon
    globals()['JsonLdObject'] = JsonLdObject
    globals()['Rgba'] = Rgba
    globals()['SpatialEntityCommon'] = SpatialEntityCommon


class SpatialSceneNode(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('transform_matrix',): {
            'max_items': 16,
            'min_items': 16,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'name': (str,),  # noqa: E501
            'tooltip': (str,),  # noqa: E501
            'unpickable': (bool,),  # noqa: E501
            'wireframe': (bool,),  # noqa: E501
            'lighting': (bool,),  # noqa: E501
            'zoom_based_opacity': (bool,),  # noqa: E501
            'zoom_to_on_load': (bool,),  # noqa: E501
            'scenegraph': (str,),  # noqa: E501
            'scenegraph_node': (str,),  # noqa: E501
            'color': (Rgba,),  # noqa: E501
            'opacity': (float,),  # noqa: E501
            'transform_matrix': ([float],),  # noqa: E501
            'priority': (float,),  # noqa: E501
            'entity_id': (str,),  # noqa: E501
            'ccf_annotations': ([str],),  # noqa: E501
            'representation_of': (str,),  # noqa: E501
            'reference_organ': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'name': 'name',  # noqa: E501
        'tooltip': 'tooltip',  # noqa: E501
        'unpickable': 'unpickable',  # noqa: E501
        'wireframe': 'wireframe',  # noqa: E501
        'lighting': '_lighting',  # noqa: E501
        'zoom_based_opacity': 'zoomBasedOpacity',  # noqa: E501
        'zoom_to_on_load': 'zoomToOnLoad',  # noqa: E501
        'scenegraph': 'scenegraph',  # noqa: E501
        'scenegraph_node': 'scenegraphNode',  # noqa: E501
        'color': 'color',  # noqa: E501
        'opacity': 'opacity',  # noqa: E501
        'transform_matrix': 'transformMatrix',  # noqa: E501
        'priority': 'priority',  # noqa: E501
        'entity_id': 'entityId',  # noqa: E501
        'ccf_annotations': 'ccf_annotations',  # noqa: E501
        'representation_of': 'representation_of',  # noqa: E501
        'reference_organ': 'reference_organ',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """SpatialSceneNode - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            name (str): [optional]  # noqa: E501
            tooltip (str): [optional]  # noqa: E501
            unpickable (bool): Whether the node should selectable by the user in interfaces.. [optional]  # noqa: E501
            wireframe (bool): Whether to show a wireframe for the node.. [optional]  # noqa: E501
            lighting (bool): [optional]  # noqa: E501
            zoom_based_opacity (bool): Whether the opacity of the node changes based on the zoom level.. [optional]  # noqa: E501
            zoom_to_on_load (bool): Focus this node when loaded in an interface.. [optional]  # noqa: E501
            scenegraph (str): [optional]  # noqa: E501
            scenegraph_node (str): [optional]  # noqa: E501
            color (Rgba): [optional]  # noqa: E501
            opacity (float): [optional]  # noqa: E501
            transform_matrix ([float]): Additional transformations to be applied.. [optional]  # noqa: E501
            priority (float): [optional]  # noqa: E501
            entity_id (str): Identifier of the entity the spatial object represents.. [optional]  # noqa: E501
            ccf_annotations ([str]): Annotations attached to the entity.. [optional]  # noqa: E501
            representation_of (str): Identifier for the item the spatial object represents.. [optional]  # noqa: E501
            reference_organ (str): Identifier for the organ the spatial object represents.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SpatialSceneNode - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            name (str): [optional]  # noqa: E501
            tooltip (str): [optional]  # noqa: E501
            unpickable (bool): Whether the node should selectable by the user in interfaces.. [optional]  # noqa: E501
            wireframe (bool): Whether to show a wireframe for the node.. [optional]  # noqa: E501
            lighting (bool): [optional]  # noqa: E501
            zoom_based_opacity (bool): Whether the opacity of the node changes based on the zoom level.. [optional]  # noqa: E501
            zoom_to_on_load (bool): Focus this node when loaded in an interface.. [optional]  # noqa: E501
            scenegraph (str): [optional]  # noqa: E501
            scenegraph_node (str): [optional]  # noqa: E501
            color (Rgba): [optional]  # noqa: E501
            opacity (float): [optional]  # noqa: E501
            transform_matrix ([float]): Additional transformations to be applied.. [optional]  # noqa: E501
            priority (float): [optional]  # noqa: E501
            entity_id (str): Identifier of the entity the spatial object represents.. [optional]  # noqa: E501
            ccf_annotations ([str]): Annotations attached to the entity.. [optional]  # noqa: E501
            representation_of (str): Identifier for the item the spatial object represents.. [optional]  # noqa: E501
            reference_organ (str): Identifier for the organ the spatial object represents.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              JsonLdObject,
              SpatialEntityCommon,
          ],
          'oneOf': [
          ],
        }
